#-*- coding:utf-8 -*-

import clr
import sys

clr.AddReferenceByPartialName("PresentationCore")
clr.AddReferenceByPartialName("PresentationFramework")
clr.AddReferenceByPartialName("WindowsBase")

from System import *
from System.IO import *
from System.Windows import *
from System.Windows.Controls import *
from System.Windows.Controls.Primitives import *
from System.Windows.Input import *
from System.Collections.ObjectModel import *
from System.Windows.Markup import XamlReader
from inifile8 import *
from xamls import *
from datas import *

class SeeMe(Window):
    """
        SeeMe MainWindow class
    """
    def __init__(self):
        """
            Window.__init__(self) is No
            Constructor has been
        """
        # Memory FilePath
        self.path = Path.GetDirectoryName(sys.argv[0])
        # Menu
        menu = XamlReader.Parse(menu_str)
        menu.FindName("menu_open").Click += self.on_open
        menu.FindName("menu_close").Click += self.on_close
        DockPanel.SetDock(menu, Dock.Top)
        # ObservableCollection
        self.engines = ObservableCollection[Engine]()
        self.Resources["engines"] = self.engines
        # ListView
        self.listview = XamlReader.Parse(listview_str)
        DockPanel.SetDock(self.listview, Dock.Top)
        self.listview.ItemsSource = self.engines
        # StatusBar
        statusbar = StatusBar()
        DockPanel.SetDock(statusbar, Dock.Bottom)
        self.statusbar_item = StatusBarItem()
        self.statusbar_item.Content = "Search.ini Version"
        statusbar.Items.Add(self.statusbar_item)
        # Read Custom search.ini
        ini_path = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\Opera\\Opera\\profile\\search.ini";
        if (File.Exists(ini_path)):
            ini = Inifile(ini_path)
            v = ini.read_int("Version", "File Version", 0)
            self.statusbar_item.Content = "Search.ini Version " + str(v)
            s = ""
            i = 0
            while 1:
                i += 1
                s = "Search Engine %i" % i
                if not ini.section_exists(s):
                    break
                en = Engine()
                en.name   = ini.read_str(s, "Name", "")
                en.key    = ini.read_str(s, "Key", "")
                en.url    = ini.read_str(s, "URL", "")
                en.delete = not ini.read_bool(s, "Deleted", False)
                en.query  = ini.read_str(s, "Query", "")
                en.post   = ini.read_bool(s, "Is post", False)
                en.endsep = ini.read_bool(s, "Has endseparator", False)
                en.encode = ini.read_str(s, "Encoding", "utf-8")
                en.type   = ini.read_int(s, "Search Type", 0)
                en.pos    = ini.read_int(s, "Position", -1)
                en.nameid = ini.read_int(s, "Nameid", 0)
                en.verb   = ini.read_int(s, "Verbtext", 0)
                en.icon   = ini.read_str(s, "ICON", "")
                en.unique = ini.read_str(s, "UNIQUEID", "")
                self.engines.Add(en)
        # DockPanel
        docpanel = DockPanel()
        docpanel.Children.Add(menu)
        docpanel.Children.Add(statusbar)
        docpanel.Children.Add(self.listview)
        # self
        self.Content = docpanel
        self.Width = 500
        self.Height = 300
        self.Title = "SeeMe for Windows v4"
        # event
        self.KeyDown += self.on_keydown

    def on_open(self, sender, e):
        """
            none
        """
        pass

    def on_close(self, sender, e):
        """
            exit
        """
        self.Close()

    def on_keydown(self, sender, e):
        """
            e as System.Windows.Input.KeyEventArgs
        """
        if Keyboard.Modifiers == ModifierKeys.Control:
            if e.Key == Key.O:
                self.on_open(self, e)
            if e.Key == Key.Q:
                self.on_close(self, e)

if __name__ == "__main__":
    a = Application()
    a.Run(SeeMe())