#-*- coding:utf-8 -*-

menu_str = """<Menu
xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml">
    <MenuItem Header="_File">
        <MenuItem Header="_Open" InputGestureText="Ctrl+O" Name="menu_open" />
        <Separator/>
        <MenuItem Header="_Quit" InputGestureText="Ctrl+Q" Name="menu_close" />
    </MenuItem>
</Menu>"""

listview_str = """<ListView
xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml">
    <ListView.Resources>
        <DataTemplate x:Key="tpl_show">
            <CheckBox IsChecked="{Binding Path=delete}" IsTabStop="False" />
        </DataTemplate>
        <Style x:Key="st_underline" TargetType="TextBlock">
            <Style.Triggers>
                <DataTrigger Binding="{Binding Path=endsep}" Value="True">
                    <Setter Property="TextDecorations" Value="Underline" />
                </DataTrigger>
                <DataTrigger Binding="{Binding Path=key}" Value="">
                    <Setter Property="Foreground" Value="Silver" />
                </DataTrigger>
                <DataTrigger Binding="{Binding Path=delete}" Value="False">
                    <Setter Property="Foreground" Value="Silver" />
                </DataTrigger>
            </Style.Triggers>
        </Style>
        <DataTemplate x:Key="tpl_name">
            <TextBlock Name="nameBlock" Text="{Binding Path=name}" HorizontalAlignment="Left" TextTrimming="CharacterEllipsis" Style="{StaticResource st_underline}" />
        </DataTemplate>
        <DataTemplate x:Key="tpl_key">
            <TextBlock Text="{Binding Path=key}" HorizontalAlignment="Left"  TextTrimming="CharacterEllipsis" />
        </DataTemplate>
        <DataTemplate x:Key="tpl_url">
            <TextBlock Text="{Binding Path=url}" HorizontalAlignment="Left"  TextTrimming="CharacterEllipsis" />
        </DataTemplate>
    </ListView.Resources>
    <ListView.View>
        <GridView>
            <GridViewColumn Header="Show" CellTemplate="{StaticResource tpl_show}" />
            <GridViewColumn Header="Name" CellTemplate="{DynamicResource tpl_name}" />
            <GridViewColumn Header="Key" CellTemplate="{StaticResource tpl_key}" />
            <GridViewColumn Header="URL" CellTemplate="{StaticResource tpl_url}" />
        </GridView>
    </ListView.View>
</ListView>"""